Index: /trunk/sources/HeuristicLab.Data/3.3/ReferenceTypeData.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/ReferenceTypeData.cs	(revision 2665)
+++ /trunk/sources/HeuristicLab.Data/3.3/ReferenceTypeData.cs	(revision 2665)
@@ -0,0 +1,74 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using System.Xml;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Data {
+  [Item("ReferenceTypeData<T>", "A base class for representing reference types.")]
+  public class ReferenceTypeData<T> : Item where T : class {
+    [Storable]
+    protected T value;
+    public T Value {
+      get { return value; }
+      set {
+        if (!value.Equals(this.value)) {
+          this.value = value;
+          OnValueChanged();
+        }
+      }
+    }
+
+    public ReferenceTypeData() {
+      value = default(T);
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      ReferenceTypeData<T> clone = (ReferenceTypeData<T>)base.Clone(cloner);
+      IDeepCloneable deepCloneable = Value as IDeepCloneable;
+      if (deepCloneable != null) {
+        clone.value = (T)deepCloneable.Clone(cloner);
+        return clone;
+      }
+      ICloneable cloneable = Value as ICloneable;
+      if (cloneable != null) {
+        clone.value = (T)cloneable.Clone();
+        return clone;
+      }
+      throw new InvalidOperationException("Contained object is not cloneable.");
+    }
+
+    public override string ToString() {
+      return value == null ? "null" : value.ToString();
+    }
+
+    public event EventHandler ValueChanged;
+    protected virtual void OnValueChanged() {
+      if (ValueChanged != null)
+        ValueChanged(this, EventArgs.Empty);
+      OnChanged();
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Data/3.3/StringData.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/StringData.cs	(revision 2664)
+++ /trunk/sources/HeuristicLab.Data/3.3/StringData.cs	(revision 2665)
@@ -28,53 +28,28 @@
 
 namespace HeuristicLab.Data {
-  /// <summary>
-  /// The representation of a string.
-  /// </summary>
   [EmptyStorableClass]
-  public class StringData : ObjectData {
-    /// <summary>
-    /// Gets or sets the string value.
-    /// </summary>
-    /// <remarks>Uses property <see cref="ObjectData.Data"/> of base class <see cref="ObjectData"/>. 
-    /// No own data storage present.</remarks>
-    public new string Data {
-      get { return (string)base.Data; }
-      set { base.Data = value; }
+  [Item("String", "Represents a string.")]
+  [Creatable("Test")]
+  public sealed class StringData : ReferenceTypeData<string>, IStringConvertibleData {
+    public StringData() : base() {
+      Value = string.Empty;
+    }
+    public StringData(string value)
+      : base() {
+      Value = value;
     }
 
-    /// <summary>
-    /// Initializes a new instance of <see cref="StringData"/> 
-    /// with the name of the type of the current instance as default value.
-    /// </summary>
-    public StringData() {
-      Data = this.GetType().Name;
-    }
-    /// <summary>
-    /// Initializes a new instance of <see cref="StringData"/> with the specified <paramref name="data"/>.
-    /// </summary>
-    /// <param name="data">The string value the current instance should represent.</param>
-    public StringData(string data) {
-      Data = data;
-    }
-
-    /// <summary>
-    /// Clones the current instance.
-    /// </summary>
-    /// <remarks>The current instance is added to the dictionary <paramref name="clonedObjects"/>.</remarks>
-    /// <param name="clonedObjects">A dictionary of all already cloned objects.</param>
-    /// <returns>The coned instance as <see cref="StringData"/>.</returns>
-    public override IItem Clone(ICloner cloner) {
-      StringData clone = new StringData();
+    public override IDeepCloneable Clone(Cloner cloner) {
+      StringData clone = new StringData(Value);
       cloner.RegisterClonedObject(this, clone);
-      clone.Data = Data;
       return clone;
     }
 
-    /// <summary>
-    /// The string representation of the current instance.
-    /// </summary>
-    /// <returns>The string value.</returns>
-    public override string ToString() {
-      return Data;
+    string IStringConvertibleData.GetValue() {
+      return Value;
+    }
+    bool IStringConvertibleData.SetValue(string value) {
+      Value = value != null ? value : string.Empty;
+      return true;
     }
   }
Index: /trunk/sources/HeuristicLab.Data/3.3/TimeSpanData.cs
===================================================================
--- /trunk/sources/HeuristicLab.Data/3.3/TimeSpanData.cs	(revision 2665)
+++ /trunk/sources/HeuristicLab.Data/3.3/TimeSpanData.cs	(revision 2665)
@@ -0,0 +1,59 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using System.Xml;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Data {
+  [EmptyStorableClass]
+  [Item("TimeSpan", "Represents a duration of time.")]
+  [Creatable("Test")]
+  public sealed class TimeSpanData : ValueTypeData<TimeSpan>, IStringConvertibleData {
+    public TimeSpanData() : base() { }
+    public TimeSpanData(TimeSpan value)
+      : base() {
+      Value = value;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      TimeSpanData clone = new TimeSpanData(Value);
+      cloner.RegisterClonedObject(this, clone);
+      return clone;
+    }
+
+    string IStringConvertibleData.GetValue() {
+      return Value.ToString();
+    }
+    bool IStringConvertibleData.SetValue(string value) {
+      TimeSpan t;
+      if (TimeSpan.TryParse(value, out t)) {
+        Value = t;
+        return true;
+      } else {
+        return false;
+      }
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Optimizer/3.3/FileManager.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimizer/3.3/FileManager.cs	(revision 2664)
+++ /trunk/sources/HeuristicLab.Optimizer/3.3/FileManager.cs	(revision 2665)
@@ -53,9 +53,13 @@
       if (newItemDialog.ShowDialog() == DialogResult.OK) {
         IView view = MainFormManager.CreateDefaultView(newItemDialog.Item);
-        if (view is IObjectView) {
-          view.Caption = "Item" + newDocumentsCounter.ToString() + ".hl";
-          newDocumentsCounter++;
+        if (view == null) {
+          MessageBox.Show("There is no view for the new item. It cannot be displayed. ", "No View Available", MessageBoxButtons.OK, MessageBoxIcon.Error);
+        } else {
+          if (view is IObjectView) {
+            view.Caption = "Item" + newDocumentsCounter.ToString() + ".hl";
+            newDocumentsCounter++;
+          }
+          MainFormManager.MainForm.ShowView(view);
         }
-        MainFormManager.MainForm.ShowView(view);
       }
     }
@@ -188,5 +192,7 @@
               Invoke(delegate() {
                 IObjectView view = MainFormManager.CreateDefaultView(item) as IObjectView;
-                if (view != null) {
+                if (view == null) {
+                  MessageBox.Show("There is no view for the loaded item. It cannot be displayed. ", "No View Available", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                } else {
                   view.Caption = Path.GetFileName(filename);
                   files.Add(view, new FileInfo(filename));
